if (typeof(simplemail) == "undefined")
  var simplemail = {a: "encoder.js"};

simplemail.SimpleMailMessageEncoder = function() {
  var pub                = {};
  pub.charset            = null,
  pub.cidNames           = [],
  pub.ContentId          = [],
  pub.ContentDisposition = [],
  pub.ContentType        = [],
  
  pub.createAttachmentHtml = function(url, message) {
    var name = simplemail.SimpleMailFile.getFileName(url);
    if(simplemail.SimpleMailDom.get("body") == null){
      var messagehtml =  message.html;
    } else {
      var messagehtml = simplemail.SimpleMailDom.get("body").contentDocument.body.innerHTML;
    }
    var myExp = new RegExp('<img src="' + simplemail.SimpleMailMessageEncoder.url0);
    if(myExp.test(messagehtml) && !simplemail.SimpleMailPrefs.getBool("plaintextOnSend")){
      return '<img src="' + url + '"' + 'alt="' + simplemail.SimpleMailFile.getFileName(url) + '">'
    } else {
     return "";
    }
  },

  pub.getAttachmentHtml = function(url, draftDisposition) {
    if (simplemail.SimpleMailPrefs.getBool("plaintextOnReceive") || simplemail.SimpleMailPrefs.getBool("plaintextOnSend")){
      return "<a class='attachment' href='" + url + "'>" + simplemail.SimpleMailFile.getFileName(url) + "</a>";
    } else {
      if (simplemail.SimpleMailFile.isImage(url) && !draftDisposition){
        return  '<img src="' + url + '"' + 'alt="' + simplemail.SimpleMailFile.getFileName(url) + '">'
      } else {
        return "<a class='attachment' href='" + url + "'>" + simplemail.SimpleMailFile.getFileName(url) + "</a>";
      } 
    }
  },    
  
  pub.getIconForAttachment = function(attachmentName){
    var extension = /.\w*$/.exec(attachmentName) 
    return "moz-icon://" + extension + "?size=16";
  },
    
  pub.encode = function(message) {
    // Base64 encode header
    function encodeHeader(string) {
      if (string && message.charset) {
        for(var i in string) {
          // Do not encode string if it contains only English characters
          if (string.charCodeAt(i) > 127) {
            return "=?" + message.charset + "?B?" +
                   btoa(simplemail.SimpleMailText.fromUnicode(string, message.charset)) + "?=";
          }
        }
      }
      return string;
    }

    function addHeader(name, value) {
      headers += name + ": " + value + "\r\n";
    }

    function addAddressHeader(name, value) {
      if (value && message.charset) {
        var addresses = simplemail.SimpleMailModel.SimpleMailAddress.parseList(value);
        for(var i in addresses) {
          addresses[i].name = encodeHeader(addresses[i].name);
        }
        value = addresses.join(", ");
      }
      if (value) addHeader(name, value);
    }

    // String concatenation on large (10 Mb) strings is time consuming,
    // It's better to write chunks to a temporary file and then read it back into memory

    function addCRLFs(string) {
      var CHUNK_LEN = 75;

      var tmpFile = simplemail.SimpleMailFile.createTemporaryFile();
      var index = 0;
      var chunk;

      while((chunk = string.substr(index, CHUNK_LEN))) {
        tmpFile.write(chunk, chunk.length);
        tmpFile.write("\r\n", 2);
        index += CHUNK_LEN;
      }
      string = tmpFile.readFully();
      tmpFile.remove();
      return string;
    }

    // Some SMTP servers don't allow lines longer than 1000 bytes (not characters).
    // If line.length > MAX_LEN then insert line break beside nearest white-space.
    // If line has no white-spaces, leave it as it is.

    function splitLongLines(string) {
      var MAX_LEN = 75;

      var result = "";
      var lines = string.split("\r\n");

      for(var i = 0; i < lines.length; i++) {
        var line = lines[i];
        if (!line) continue; // Skip empty lines
        do {
          var index = line.length > MAX_LEN ? line.lastIndexOf(" ", MAX_LEN) : -1;
          result += (index != -1 ? line.substr(0, index) : line) + "\r\n";
        }
        while(index != -1 && (line = line.substr(index + 1)));
      }
      return result;
    }
    
    function encodeBody() {
      var attachments = new Array();

      message.html = simplemail.SimpleMailText.replaceURLs(message.html,
        function(text, url, image) {
          if (!image && !simplemail.SimpleMailFile.isLocalURL(url)) return text;
          url = url.replace(/&amp;/gi, "&"); // Decode html entities
          message.attachmentsCount++;

          var name = simplemail.SimpleMailFile.getFileName(url);
          attachments[name] = {
            url: url,
            cid: simplemail.SimpleMailUtils.getUniqueId() + "@simplemail"
          };
          
          simplemail.SimpleMailMessageEncoder.url0 = url;
          var newUrl = simplemail.SimpleMailFile.getAttachmentURL(message.attachmentsDir, name);
          return simplemail.SimpleMailMessageEncoder.createAttachmentHtml(newUrl, message);
        });

      // If plaintext remove somes HTML tags      
      if (simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
        var html = message.html.replace(/<[\/]{0,1}(span|font|p|div)[^><]*>/g,"");
        var html = html.replace(/<\s*a[^>]*>(.*?)<\s*\/\s*a>{1,}/ig,"");
      } else {
        var html = "<html>\r\n   <head>\r\n" + "      <meta http-equiv=\"" + 
                   "content-type" + "\"" + " content: text/html; charset=" + message.charset + ">\r\n" +
                   "   </head>\r\n" + "<body>\r\n" + message.html + "\r\n</body>\r\n</html>";
      }
      
      html = simplemail.SimpleMailText.replaceURLs(html,
        function(text, url) {
          if (!url.match(/^simplemail:/)) return text;

          var name = simplemail.SimpleMailFile.getFileName(url);
          var regexp = url.replace(/[\/\(\)\[\]\{\}\.\+\?]/g, function($0) { return "\\" + $0; });
          return text.replace(new RegExp(regexp, "g"), "cid:" + attachments[name].cid);
        });

      // Replace "bare LFs", some mail servers don't accept them
      html = html.replace(/(^|[^\r])\n+/g, function($0) {
                                             return $0.replace(/\n/g, "\r\n");
                                           });
    // Replace <br> with \r\n
    if (simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
      html = html.replace(/(<br>).*?/g,"\r\n");
      html = "--" + boundary + "\r\n" +
             "Content-Type: text/plain; charset=" + message.charset + "\r\n" +
             "Content-Transfer-Encoding: 7bit\r\n" +
             "\r\n" + simplemail.SimpleMailText.fromUnicode(splitLongLines(html), message.charset);
    } else { 
      // Replace <br> with <br>\r\n to beautify result html
      html = html.replace(/(<br.*?>)(?!\r)/g, "$1\r\n");  
      html = "--" + boundary + "\r\n" +
             "Content-Type: text/html; charset=" + message.charset + "\r\n" +
             "Content-Transfer-Encoding: 7bit\r\n" +
             "\r\n" + simplemail.SimpleMailText.fromUnicode(splitLongLines(html), message.charset);
    };

      for(var name in attachments) {
        var attachment = attachments[name]
        var contents = readURL(attachment.url);
        name = name.toString().replace(/[\'\[\]\(\)] */gi, "_");
        simplemail.SimpleMailFile.saveAttachment(message.attachmentsDir, name, contents);

        if (simplemail.SimpleMailFile.isImage(attachment.url) || name == "MDNFile.txt") { 
          var disposition = "inline";
        } else {
          var disposition = "attachment";
        }

        name = encodeHeader(name);

        if(name == "MDNFile.txt") {
          var conType = "message/disposition-notification";
        } else {
          var conType = simplemail.SimpleMailFile.getMimeType(attachment.url);
          var ext = simplemail.SimpleMailFile.getFileExtension(attachment.url);
          if (ext == "pdf") {
            var conType = "application/pdf";
          }  
        }

        if (simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) { 
          html += "--" + boundary + "\r\n" +
                  "Content-Type: " + conType +";\r\n" +
                  " name=\"" + name + "\"\r\n" +
                  "Content-Transfer-Encoding: base64\r\n" +
                  // "Content-ID: <" + attachment.cid + ">\r\n" +      // No Content-ID for Eudora
                  "Content-Disposition: attachment;\r\n" +
                  " filename=\"" + name + "\"\r\n" + "\r\n" +
                  addCRLFs(btoa(contents));
        } else {
        
          html += "--" + boundary + "\r\n" +
                  "Content-Type: " + conType + ";\r\n" +
                  " name=\"" + name + "\"\r\n" +
                  "Content-Transfer-Encoding: base64\r\n" +
                  "Content-ID: <" + attachment.cid + ">\r\n" +
                  "Content-Disposition: " + disposition + ";\r\n" +
                  " filename=\"" + name + "\"\r\n" + "\r\n" +
                  addCRLFs(btoa(contents));        
        }
      }
      
        function readURL(url) {
          var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                          .getService(Components.interfaces.nsIIOService);
          var bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
                        .createInstance(Components.interfaces.nsIBinaryInputStream);
          var channel = ioService.newChannel(url, null, null);
          
          var input = channel.open();
          bstream.setInputStream(input);
      
          var size, data = "";
          while((size = bstream.available())) {
            data += bstream.readBytes(size);
          }
          return data;
        }
      
      return html + "--" + boundary + "--\r\n";
    }

    var headers = "";
    message.date = new Date().getTime();
    addHeader("Date", simplemail.SimpleMailDate.toMIME(message.date));
    addAddressHeader("Disposition-Notification-To", message.returnReceiptTo);
    addAddressHeader("From", message.from);
    addHeader("User-Agent", "Simple Mail V" + simplemail.SimpleMailPrefs.getString("version"));
    addHeader("MIME-Version", "1.0");
    addAddressHeader("Reply-To", message.replyTo);
    addAddressHeader("To", message.to);
    addAddressHeader("Cc", message.cc);
    addAddressHeader("Bcc", message.bcc);
    addHeader("Subject", encodeHeader(message.subject));
    var boundary = "----------simplemail" + simplemail.SimpleMailUtils.getUniqueId();
    if(message.subject.match(/^(Rcpt:)/i)){
      addHeader("Content-Type", "multipart/report; report-type=disposition-notification;\r\n boundary=" + boundary);
    } else {
      addHeader("Content-Type", "multipart/related;\r\n boundary=" + boundary);
    }
    return headers + "\r\n" + encodeBody();
  },

  pub.parse = function(source, attachments, cidNames, ContentId, ContentDisposition, ContentType) {
    function Part(source) {
      var self = this;
      var headers = getHeaders();

      function getHeaders() {
        var end = source.indexOf("\r\n\r\n");
        return (end != -1) ? source.substr(0, end + 2) : source;
      }

      this.getHeader = function(name) {
        // Headers may be multiline (RFC 2822: "folding")
        var regexp = new RegExp("(^|\\r\\n)" + name +
                                " *: *((.|\\r\\n\\s)*) *\\r\\n", "i");
        var result = regexp.exec(headers);
        if (result) {
          result = result[2].replace(/\r\n\s+/g, ""); // Unfold (RFC 2822)
          return decodeHeader(result);
        }
        return "";
      }

      // Removes redundant quotes, etc.
      function cleanAddressList(list) {
        var addresses = simplemail.SimpleMailModel.SimpleMailAddress.parseList(list);
        return addresses.join(", ");
      }

      this.getAddressHeader = function(name) {
        return cleanAddressList(self.getHeader(name));
      }

      // Decode Quoted Printable string
      function qp(string) {
        return string.replace(/=\r\n|=(..)/g, function($0, $1) {
          return ($0 != "=\r\n") ? String.fromCharCode("0x" + $1) : "";
        });
      }

      function atob_fixed(str) {
        try {
          return str ? atob(str.replace(/=+$/, "")) : str;
        }
        catch(e) {
          return simplemail.SimpleMailUtils.error("messageParseError", [e]);
        }
      }

      // Decode Base64 / Quoted Printable encoded header
      function decodeHeader(string) {
        if (string) {
          simplemail.SimpleMailMessageEncoder.charset = message.charset;
          var regexp = /=\?(.*?)\?([BQ])\?(.*?)\?=/gi;
          string = string.replace(regexp, function($0, $1, $2, $3) {
            simplemail.SimpleMailMessageEncoder.charset = $1;
            return $2 == 'B' || $2 == 'b' ? atob_fixed($3)
                                          : qp($3).replace(/_/g, " ");
          });
          try {
            string = simplemail.SimpleMailText.toUnicode(string, simplemail.SimpleMailMessageEncoder.charset);
          }
          catch(e) {}
        }
        return string;
      }

      function getByRegexp(string, regexp) {
        var result = regexp.exec(string);
        return result ? result[1] : "";
      }

      function getContentType() {
        var ContentType = self.getHeader("Content-Type");
        return getByRegexp(ContentType, /([^;\s]*)/);
      }

      function getBoundary() {
        var ContentType = self.getHeader("Content-Type");
        return getByRegexp(ContentType, /boundary *= *['"]?([^;\r'"]*)/i);
      }

      this.getCharset = function() {
        var ContentType = self.getHeader("Content-Type");
        return getByRegexp(ContentType, /charset *= *['"]?([^;\s'"]*)/i);
      }

      function getFileName() {
        var ContentDisposition = self.getHeader("Content-Disposition");
        var ContentType = self.getHeader("Content-Type");
        var regexp = /(file)?name *= *['"]?([^;\r"]*)/i;
        var result = regexp.exec(ContentDisposition) || regexp.exec(ContentType);
        return result ? result[2].replace(/[\'\[\]\(\)]/g, "_") : "";
      }

      function getContentId() {
        var cid = self.getHeader("Content-ID");
        if (cid) return cid.replace(/^<|>$/g, "");
      }

      function isAttachment() {
        var ContentDisposition1 = self.getHeader("Content-Disposition");
        var value = getByRegexp(ContentDisposition1, /([^;\s]*)/);
        return value.toLowerCase() == "attachment";
      }

      // String.replace(/\r\n/g, "") on large (10 Mb) strings is time consuming,
      // It's better to split() string, write chunks to a temporary file and then read it back into memory

      function stripCRLFs(string) {
        var tmpFile = simplemail.SimpleMailFile.createTemporaryFile();
        var chunks = string.split(/\r?\n/);
        for(var i in chunks) {
          tmpFile.write(chunks[i], chunks[i].length);
        }
        string = tmpFile.readFully();
        tmpFile.remove();
        return string;
      }

      function getBody() {
        var start = source.indexOf("\r\n\r\n");
        if (start == -1) return "";

        var body = source.substr(start + 4);
        var encoding = self.getHeader("Content-Transfer-Encoding");

        if (encoding.match(/base64/i)) {
          var end = body.lastIndexOf("=");
          if (end != -1) body = body.substr(0, end + 1);
          body = atob_fixed(stripCRLFs(body));
        }
        else if (encoding.match(/quoted-printable/i)) {
          body = qp(body);
        }

        simplemail.SimpleMailMessageEncoder.charset = self.getCharset();
        try {
          body = simplemail.SimpleMailText.toUnicode(body, simplemail.SimpleMailMessageEncoder.charset);
          if (!message.charset) message.charset = simplemail.SimpleMailMessageEncoder.charset;
        }
        catch(e) {}
        return body;
      }

      function parseMultipart() {
        var html = "";
        var parts = source.split("--" + getBoundary());
        var count = parts.length;
        if (parts[count - 1].match(/^--/)) count--;

        if (simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
          var i = getContentType().match(/multipart\/alternative/i) ? count -1 : 1;

          for(; i >= 1 && i < count; i++) {
            var htmlTemp = htmlTemp + new Part(parts[i]).toHtml();
          }
          html += new Part(parts[1]).toHtml();
          return html;
        }          
        else {
          // For multipart/alternative take the latest alternate part
          var i = getContentType().match(/multipart\/alternative/i) ? count - 1 : 1;

          for(; i >= 1 && i < count; i++) {
            html += new Part(parts[i]).toHtml();
          }
        return html;
        }
      }

      function parseAttachment(body) {
        var name = getFileName() || simplemail.SimpleMailUtils.getUniqueId();
        attachments[name] = body;
        var cid = getContentId();
        var disposition = self.getHeader("Content-Disposition");
        var type = self.getHeader("Content-Type");
        if (name) {
          simplemail.SimpleMailMessageEncoder.ContentDisposition[name] = disposition;
          simplemail.SimpleMailMessageEncoder.ContentType[name] = type;
        }
        if (cid) {
          for(var i in cid) {
            simplemail.SimpleMailMessageEncoder.ContentId[i] = cid;
          }
            simplemail.SimpleMailMessageEncoder.cidNames[cid] = name
        };

        return "";
      }

      // Some mail servers split lines longer than 1000 bytes by inserting "\r\n\s".
      // When such string is inserted inside html attribute, html gets broken.

      function repairHtml(html) {
        return html.replace(/<[^>]+>/g, function(tag) {
          return tag.replace(/["'][^'"]+["']/g, function(attribute) {
            return attribute.replace(/\r\n\s/g, "");
          });
        });
      }

      this.toHtml = function() {
        var ContentType = getContentType();
        if (ContentType.match(/^multipart/i)) return parseMultipart();
         
        var body = getBody();

        if (!isAttachment()) {
          if (!ContentType || ContentType.match(/text\/plain/i)) {
            return simplemail.SimpleMailText.toHtml(body);
          }
          else if (ContentType.match(/text\/html/i)) {
            return repairHtml(body);
          }
          else if (ContentType.match(/message\/rfc822/i)) {
            var msg = simplemail.SimpleMailMessageEncoder.parse(body, attachments, simplemail.SimpleMailMessageEncoder.cidNames, simplemail.SimpleMailMessageEncoder.ContentId, simplemail.SimpleMailMessageEncoder.ContentDisposition, simplemail.SimpleMailMessageEncoder.ContentType);
            return "<hr>" + msg.toHtml();
          }
        }
        return parseAttachment(body);
      }
    }

    var message = new simplemail.SimpleMailModel.SimpleMailMessage();
    var part = new Part(source);
    message.html = part.toHtml();
    message.source = source;
    message.size = source.length; 
    message.date = simplemail.SimpleMailDate.parse(part.getHeader("Date"));
    message.subject = part.getHeader("Subject");
    message.from = part.getAddressHeader("From");
    message.to = part.getAddressHeader("To");
    message.cc = part.getAddressHeader("Cc");
    message.bcc = part.getAddressHeader("Bcc");
    message.replyTo = part.getAddressHeader("Reply-To");
    message.returnReceiptTo = part.getAddressHeader("Disposition-Notification-To") ||
                              part.getAddressHeader("Return-Receipt-To");
    return message;
  },

  pub.decode = function(source, create) {
    var attachments = [];
    var message = simplemail.SimpleMailMessageEncoder.parse(source, attachments, simplemail.SimpleMailMessageEncoder.cidNames, simplemail.SimpleMailMessageEncoder.ContentId, simplemail.SimpleMailMessageEncoder.ContentDisposition, simplemail.SimpleMailMessageEncoder.ContentType);
    simplemail.SimpleMailMessageEncoder.linked = [];
     
    message.html = simplemail.SimpleMailText.replaceURLs(message.html,
      function(text, url) {
        return simplemail.SimpleMailFile.isLocalURL(url) ? "" : text;
      });
     
    message.html = message.html.replace(/cid:([^'"]*)/gi,
      function(text, cid) {
        var name = simplemail.SimpleMailMessageEncoder.cidNames[cid];
        if (!name) return text;
        name = name.toString().replace(/[\'\[\]\(\)] */gi, "_");
        simplemail.SimpleMailMessageEncoder.linked[name] = true;
        return simplemail.SimpleMailFile.getAttachmentURL(message.attachmentsDir, name);
      });

    for(var name in attachments) {
      message.attachmentsCount++;
      if (!create){
        name = name.toString().replace(/[\'\[\]\(\)] */gi, "_")
        try {
          simplemail.SimpleMailFile.saveAttachment(message.attachmentsDir, name, attachments[name]);
        }
        catch(e) {
          simplemail.SimpleMailUtils.error("messageParseError", [e]);
        }
      }  
      if (!simplemail.SimpleMailMessageEncoder.linked[name]) {
        name = name.toString().replace(/[\'\[\]\(\)] */gi, "_");
        var newUrl = simplemail.SimpleMailFile.getAttachmentURL(message.attachmentsDir, name);
        message.html += simplemail.SimpleMailMessageEncoder.getAttachmentHtml(newUrl);
      }
    }
    return message;
  }
  return pub;
}();