if (typeof(simplemail) == "undefined")
  var simplemail = {a: "address.js"};

simplemail.SimpleMailAdresses = function() {
  var pub = {addressTree: null, addresses: null, group: [], groupTree: [], address: null};
    
  // userok
  pub.updateAddressTree = function() {
    var sortParam = simplemail.SimpleMailAdresses.getSort();
    //console.error("SM.addressTreeView_updateAddressTree", sortParam);//userok_log
    if (sortParam) {
      simplemail.SimpleMailAdresses.addresses.sort(function(a, b) {
        var vA = a[sortParam[0]].toLowerCase();
        var vB = b[sortParam[0]].toLowerCase();
        if (vA > vB == sortParam[1])
          return 1
        else if (vA < vB == sortParam[1])
          return -1
        else
          return 0;
      });
    }
    //var oldCount = simplemail.SimpleMailAdresses.addresses.length;
    //simplemail.SimpleMailAdresses.addresses = simplemail.SimpleMailOverlay.storage.get/Addresses(null, simplemail.SimpleMailAdresses.getSort());
    //simplemail.addressTreeView.treebox.rowCountChanged(0, simplemail.SimpleMailAdresses.addresses.length - oldCount);
    //simplemail.addressTreeView.treebox.rowCountChanged(0, -1);
    simplemail.addressTreeView.treebox.invalidate();
  },
  
  pub.initAddresses = function() {
    simplemail.SimpleMailAdresses.addresses        = simplemail.SimpleMailOverlay.storage.getAddresses();
    simplemail.SimpleMailAdresses.addressTree      = simplemail.SimpleMailDom.get("address-tree");
    simplemail.SimpleMailAdresses.addressTree.view = simplemail.addressTreeView;
    if (simplemail.SimpleMailAdresses.addressTree.view.rowCount > 0) 
      simplemail.SimpleMailAdresses.addressTree.view.selection.select(0);
    simplemail.SimpleMailAdresses.updateAddressTree();
  },
  
  // userok
  pub.initialize = function() {
    //console.error("SM.SimpleMailAdresses_initialize", this, window);//userok_log  
    
    simplemail.SimpleMailAdresses.address = window.arguments[0].address;
    simplemail.SimpleMailOverlay          = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
  
    document.title = simplemail.SimpleMailAdresses.address.id ? 
      simplemail.SimpleMailBundle.getString("editAddress", [simplemail.SimpleMailAdresses.address]) : simplemail.SimpleMailBundle.getString("newAddress");
    simplemail.SimpleMailDom.get("name").value          = simplemail.SimpleMailAdresses.address.name;
    simplemail.SimpleMailDom.get("email").value         = simplemail.SimpleMailAdresses.address.email;
    simplemail.SimpleMailDom.get("postaladdress").value = simplemail.SimpleMailAdresses.address.postaladdress;
    simplemail.SimpleMailDom.get("phone").value         = simplemail.SimpleMailAdresses.address.phone;
    simplemail.SimpleMailDom.get("type").value          = simplemail.SimpleMailAdresses.address.group ? "group" : "email";
    simplemail.SimpleMailDom.get("name").focus();  
  
    simplemail.SimpleMailAdresses.groupTree      = simplemail.SimpleMailDom.get("group-tree");
    simplemail.SimpleMailAdresses.groupTree.view = simplemail.groupTreeView;
    simplemail.SimpleMailAdresses.setGroupIds(simplemail.SimpleMailAdresses.address.group);
  
    simplemail.SimpleMailAdresses.initAddresses();
    simplemail.addressTreeView.action = simplemail.SimpleMailAdresses.addToGroup;
    simplemail.addressTreeView.delete = function() {};
  },
  
  // userok: rewrited
  pub.checkValues = function(name, email, isGroup) {
    //console.error("SM.checkValues", name, email, isGroup);//userok_log 
    
    if (isGroup) {
      if (!name) {
        simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("specifyGroupName"));
        return false;
      } else
        return true;
    }
    
    if (!email) {
      simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("specifyEmail"));
      return false;
    }

    // check is valid
    if (!email.toLowerCase().match(/^[a-z0-9._%+-]+@(?:[a-z0-9-])/gim)) {
      simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("addressAlert"));
      return false;
    }
    
    // check is already exist
    for (var i in simplemail.SimpleMailAdresses.addresses) {
      var amail = (simplemail.SimpleMailAdresses.address.email) ? simplemail.SimpleMailAdresses.address.email.toLowerCase() : null;
      if (simplemail.SimpleMailAdresses.addresses[i].email.toLowerCase() == email.toLowerCase() && email.toLowerCase() !== amail) {
        simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("accountAlert"));
        return false;
      }
    }

    return true;
  },
  
  // userok
  pub.onAccept = function() {
    //console.error("SM.Addresses_onAccept", window);//userok_log  
    
    var isGroup = (simplemail.SimpleMailDom.get("type").value == "group");
    var name    = simplemail.SimpleMailDom.get("name").value;
    var email   = simplemail.SimpleMailDom.get("email");
    var phone   = simplemail.SimpleMailDom.get("phone").value;
    if (phone == "undefined") 
      phone = ""; 
    
    if (!simplemail.SimpleMailAdresses.checkValues(name, email.value, isGroup)) {
      email.value = simplemail.SimpleMailAdresses.address.email;  
      email.focus();
      return false;
    }

    simplemail.SimpleMailAdresses.address.postaladdress = simplemail.SimpleMailDom.get("postaladdress").value;
    simplemail.SimpleMailAdresses.address.name          = name;
    simplemail.SimpleMailAdresses.address.phone         = phone;
    simplemail.SimpleMailAdresses.address.group         = (isGroup)  ? simplemail.SimpleMailAdresses.getGroupIds(simplemail.SimpleMailAdresses.group) : "";
    simplemail.SimpleMailAdresses.address.email         = (!isGroup) ? email.value : "";

    return true;
  },

  pub.onCancel = function() {
    window.arguments[0].address = null;
  },
  
  pub.getGroupIds = function(items) {
    var ids = "";
    for (var i = 0; i < items.length; i++) {
      if (ids) 
        ids += ",";
      ids += items[i].id;
    }
    return ids;
  },
  
  pub.setGroupIds = function(strids) {  
    var oldCount = simplemail.SimpleMailAdresses.group.length;
    var arrIds   = strids.split(",");
    simplemail.SimpleMailAdresses.group = simplemail.SimpleMailOverlay.storage.getAddressesByIds(arrIds); // userok
    simplemail.groupTreeView.treebox.rowCountChanged(0, simplemail.SimpleMailAdresses.group.length - oldCount);
    simplemail.groupTreeView.treebox.invalidate();
    //console.error("SM_setGroupIds", strids, simplemail.SimpleMailAdresses.group);//userok_log
  },
  
  pub.addToGroup = function() {
    simplemail.SimpleMailDom.get("type").value = "group";
  
    var items = [];
    simplemail.addressTreeView.forEachSelected(function(index) {
      items.push(simplemail.SimpleMailAdresses.addresses[index]);
    });
    
    items = simplemail.SimpleMailAdresses.group.concat(items);
    simplemail.SimpleMailAdresses.setGroupIds(simplemail.SimpleMailAdresses.getGroupIds(items));
  },
  
  pub.deleteFromGroup = function() {
    simplemail.groupTreeView.forEachSelected(function(index) {
      simplemail.SimpleMailAdresses.group.splice(index, 1);
      simplemail.groupTreeView.treebox.rowCountChanged(index, -1);
    });
  },
  
  // userok: async
  pub.editAddress = function(add) {
    //console.error("SM.editAddress", add, this);//userok_log
    var taddress = add ? simplemail.SimpleMailModel.SimpleMailAddress.create() : simplemail.SimpleMailAdresses.addresses[simplemail.SimpleMailAdresses.addressTree.currentIndex];
    var param    = { address: taddress };
  
    openDialog("chrome://simplemail/content/main/address.xul", "simplemail-preferences-address-window", "chrome,centerscreen,modal,resizable", param);
    if (param.address) {
      if (add) {
        simplemail.SimpleMailAdresses.addresses.push(taddress);
        var len = simplemail.addressTreeView.rowCount - 1;
        simplemail.addressTreeView.treebox.rowCountChanged(len, 1);
        simplemail.SimpleMailAdresses.addressTree.view.selection.select(len);
      } else 
        simplemail.addressTreeView.treebox.invalidateRow(simplemail.SimpleMailAdresses.addressTree.currentIndex);
      // async save
      simplemail.SimpleMailOverlay.storage.saveAddress(function(addr) {
        
      }, taddress);
    }
  },

  // userok: async
  pub.deleteAddress = function() {
    if (simplemail.SimpleMailUtils.confirm(simplemail.SimpleMailBundle.getString("deleteAddresses"))) {
      // get selected
      var ids = [];
      simplemail.addressTreeView.forEachSelected(function(index) {
        ids.push(simplemail.SimpleMailAdresses.addresses[index].id);
        simplemail.SimpleMailAdresses.addresses.splice(index, 1);
        simplemail.addressTreeView.treebox.rowCountChanged(index, -1);
      });

      // userok: async delete
      if (ids.length > 0) {
        simplemail.SimpleMailOverlay.storage.deleteAddress(function() {
          simplemail.SimpleMailAdresses.addressTree.view.selection.clearSelection();
        }, ids);
      }
    }
  },  

  pub.onSelectAddress = function() {
    var count = !simplemail.SimpleMailAdresses.addressTree.view.selection.getRangeCount();
    var edit  = simplemail.SimpleMailDom.get("address-edit"), deletee = simplemail.SimpleMailDom.get("address-delete");
    if (edit.nodeName == "button") 
      edit.disabled = deletee.disabled = count;
    else 
      edit.hidden = deletee.hidden = count;
  },
  
  pub.getSort = function() {
    var column = simplemail.addressTreeView.getSortedColumn();
    if (!column) 
      return;
  
    var direction = column.getAttribute("sortDirection");
    if (direction) {
      var sortColumns = {
        "address-name"          : "name",
        "address-email"         : "email",
        "address-favorite"      : "favorite",
        "address-postaladdress" : "addressp",
        "address-phone"         : "phonep"
      };
      var id = sortColumns[column.id] || column.id;
      //return id + " " + (direction == "descending" ? "DESC" : "ASC"); // userok
      return [id, direction == "ascending"];   // userok
    }
  }
  
  return pub;
}();

simplemail.groupTreeView = function () {
  var pub = {  
    get rowCount() {
      return simplemail.SimpleMailAdresses.group.length;
    }
  };

  pub.getCellText = function(row, column) {
    var name = column.id.replace(/group-/, "");
    return simplemail.SimpleMailAdresses.group[row][name];
  },
  
  pub.action = simplemail.SimpleMailAdresses.deleteFromGroup,
  pub.delete = simplemail.SimpleMailAdresses.deleteFromGroup

  return pub;
}();

simplemail.DefaultTreeView.extend(simplemail.groupTreeView);

simplemail.addressTreeView = function () {
  var pub = {
    get rowCount() {
      return simplemail.SimpleMailAdresses.addresses.length;
    }
  };

  pub.getCellText = function(row, column) {
    var name = column.id.replace(/address-/, "");
    return simplemail.SimpleMailAdresses.addresses[row][name];
  },
  
  pub.getCellProperties = function(row, column, props) {
    var taddress = simplemail.SimpleMailAdresses.addresses[row];
    if (taddress.group) {
      if (props) {
        var atom = simplemail.addressTreeView.atomService.getAtom("group");
        props.AppendElement(atom);
      } else 
        return "group";
    }
  },
  
  pub.isEditable = function(row, column) {
    return column.id == "address-favorite";
  },
  
  pub.getCellValue = function(row, column) {
    return simplemail.SimpleMailAdresses.addresses[row].favorite ? "true" : "false";
  },
  
  // userok: async
  pub.setCellValue = function(row, column, value) {
    simplemail.SimpleMailAdresses.addresses[row].favorite = (value == "true");
    simplemail.SimpleMailOverlay.storage.saveAddress(function(addr) {
      simplemail.addressTreeView.cycleCell(row, column);
    }, simplemail.SimpleMailAdresses.addresses[row]);
  },
  
  pub.action = function() {
    var idx = simplemail.SimpleMailAdresses.addressTree.currentIndex;
    if (idx != -1) {
      var taddress = simplemail.SimpleMailAdresses.addresses[idx];
      simplemail.messageTreeView.openNew(taddress.toString());
    }
  },
  
  pub.cycleHeader = function(column) {
    //console.error("SM.addressTreeView_cycleHeader", column);//userok_log
    column = simplemail.SimpleMailDom.get(column.id);
    var sortedColumn = simplemail.addressTreeView.getSortedColumn();
    if (sortedColumn && sortedColumn != column)
      sortedColumn.removeAttribute("sortDirection");
  
    var direction = column.getAttribute("sortDirection");
    column.setAttribute("sortDirection", simplemail.addressTreeView.nextDirection[direction]);
    
    simplemail.SimpleMailAdresses.updateAddressTree();
  },
  
  pub.delete = simplemail.SimpleMailAdresses.deleteAddress
  
  return pub;
}();

simplemail.DefaultTreeView.extend(simplemail.addressTreeView);