if (typeof(simplemail) == "undefined")
  var simplemail = {a: "main.js"};

simplemail.SimpleMailMain = function() {
  var pub = {};

  pub.initialize = function() {
    if (initialized) 
      return;
    initialized = true;

    // userok: drop obsolete simplemail.SimpleMailDom.remove("gr/ippy-style");
    simplemail.SimpleMailMain.initToolbarMode();
    
    // Important: Do not allow mail messages to execute javascript,
    // Because this javascript would be executed with chrome privileges
    simplemail.SimpleMailDom.get("body").docShell.allowJavascript    = false;
    simplemail.SimpleMailDom.get("printer").docShell.allowJavascript = false;
    
    simplemail.SimpleMailDom.get("body").contentDocument.addEventListener("keypress", function(evt) {
      if (!evt.ctrlKey || String.fromCharCode(evt.charCode) != 'a') {
        simplemail.messageTreeView.onKeyPress(evt);
      }
    }, false);
    
    simplemail.SimpleMailOverlay = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
    //console.error("SM.SimpleMailMain_initialize", simplemail.SimpleMailOverlay, this);//userok_log
    
    SimpleMail_updateFavIcon();
    
    messages         = [];
    messageTree      = simplemail.SimpleMailDom.get("message-tree");
    messageTree.view = simplemail.messageTreeView;
    
    folders         = simplemail.SimpleMailOverlay.storage.getFolders();
    folderTree      = simplemail.SimpleMailDom.get("folder-tree");
    folderTree.view = simplemail.folderTreeView;
    simplemail.SimpleMailAdresses.initAddresses();
    //console.error("SM.SimpleMailMain_initialize", folders, this);//userok_log
    
    if (simplemail.SimpleMailPrefs.getBool("nospam")){
      simplemail.SimpleMailDom.get("asspam").hidden = true;
      simplemail.SimpleMailDom.get("spam").hidden   = true;
    } else
      simplemail.SimpleMailDom.get("spam").hidden   = false;
     
    simplemail.SimpleMailManageFolder.displayInbox();
    
    var browserWindow = simplemail.SimpleMailUtils.getBrowserWindow();
    var tabContainer  = browserWindow.getBrowser().selectedTab;
    tabContainer.addEventListener("TabClose", simplemail.SimpleMailMain.onTabClose, false);
    
    /*var stat = simplemail.SimpleMailOverlay.get/Status(); // from 2.86.7
    if (stat == "loading") {
      var counter = 10;
      simplemail.SimpleMailMain.showProgress(counter);
    }*/
  },

  pub.showProgress = function(counter) {
    //var stat = simplemail.SimpleMailOverlay.get/Status(); // userok
    //if (stat == "loading") {                              // userok
    if (simplemail.SimpleMailOverlay.instances.length) {    // userok
      counter = counter + 5;
      if (counter == 105)
        counter = 0;

      var win = simplemail.SimpleMailOverlay.getMainWindow();
      win.document.getElementById("progressMeter").collapsed  = false; 
      win.document.getElementById("cancelcheck").hidden       = false;
      win.document.getElementById("progressMeterText").hidden = false;
      win.document.getElementById("progressMeter").value      = counter;
      simplemail.SimpleMailOverlay.updateIcons();
      setTimeout(function() {
        simplemail.SimpleMailMain.showProgress(counter);
      }, 100);
    }
  },

  pub.switchLayout = function() {
    var orient = (simplemail.SimpleMailDom.get("right-column").orient == "horizontal") ? "vertical" : "horizontal";
    simplemail.SimpleMailDom.get("right-column").orient   = orient;
    simplemail.SimpleMailDom.get("right-splitter").orient = orient;
  },

  pub.switchHeaders = function() {
    simplemail.SimpleMailDom.get("headers").collapsed = !simplemail.SimpleMailDom.get("headers").collapsed;
  },
      
  pub.initToolbarMode = function() {
    var mode = simplemail.SimpleMailPrefs.getString("toolbarMode");
    simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", mode);

    var menuitems = simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
    for(var i = 0; i < menuitems.length; i++) {
      if (menuitems[i].value == mode) {
        menuitems[i].setAttribute("checked", true);
      }
    }
    if (simplemail.SimpleMailPrefs.getBool("old")) {
      simplemail.SimpleMailDom.remove("nuvola-style");
      simplemail.SimpleMailDom.remove("oxygen-style");
      simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (simplemail.SimpleMailPrefs.getBool("nuvola")) {
      simplemail.SimpleMailDom.remove("old-style");
      simplemail.SimpleMailDom.remove("oxygen-style");
      simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (simplemail.SimpleMailPrefs.getBool("oxygen")) {
      simplemail.SimpleMailDom.remove("old-style");
      simplemail.SimpleMailDom.remove("nuvola-style");
      simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (simplemail.SimpleMailPrefs.getBool("australis")) {
      simplemail.SimpleMailDom.remove("old-style");
      simplemail.SimpleMailDom.remove("nuvola-style");
      simplemail.SimpleMailDom.remove("oxygen-style");
    }
  },

  pub.updateToolbarMode = function() {
    var menuitems = simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
    for(var i = 0; i < menuitems.length; i++) {
      if (menuitems[i].getAttribute("checked")) {
        simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
        simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", menuitems[i].value);
      }
    }
  },
  
  pub.archiveFolder = function() {
    var param = {
        inn: {
          folder:     simplemail.SimpleMailManageFolder.getCurrentFolder(), 
          folders:    simplemail.SimpleMailOverlay.storage.getFolders(), 
          folderTree: simplemail.SimpleMailDom.get("folder-tree")}, 
        out: null};

    openDialog("chrome://simplemail/content/archive.xul", "simplemail-archive-window", "chrome,modal,centerscreen,resizable", param);
    if (param.out) {
      folders         = simplemail.SimpleMailOverlay.storage.getFolders();
      folderTree      = simplemail.SimpleMailDom.get("folder-tree");
      folderTree.view = simplemail.folderTreeView;
      simplemail.SimpleMailManageFolder.updateFolderCounts();
      simplemail.SimpleMailManageFolder.displayInbox();
      simplemail.messageTreeView.displayFolder();
    }
  },
  
  pub.openSPAMOptions = function() {
    if (!simplemail.SimpleMailOverlay.spamWindow || simplemail.SimpleMailOverlay.spamWindow.closed) {
      var param = {
        inn: {
          folder:          simplemail.SimpleMailManageFolder.getCurrentFolder(), 
          folders:         simplemail.SimpleMailOverlay.storage.getFolders(), 
          folderTree:      simplemail.SimpleMailDom.get("folder-tree"), 
          folderTreeView:  simplemail.folderTreeView, 
          messageTreeView: simplemail.messageTreeView}, 
        out: null};
        
      simplemail.SimpleMailOverlay.spamWindow = openDialog("chrome://simplemail/content/preferences/spamprefs.xul",
        "simplemail-spam-window", "chrome,modal,centerscreen,resizable", param);
    } else 
      simplemail.SimpleMailOverlay.spamWindow.focus();
  },
  
  pub.onTabClose = function(event) {
    if (event.target.linkedBrowser.contentDocument == document) 
      simplemail.SimpleMailMain.onClose();
  },
  
  pub.onUnload = function() {
    var browserWindow = simplemail.SimpleMailUtils.getBrowserWindow();
    if (browserWindow !== null) {
      var tabContainer = browserWindow.getBrowser().selectedTab;
      tabContainer.removeEventListener("TabClose", simplemail.SimpleMailMain.onTabClose, false);
    }
  },
  
  pub.onClose = function() {
    if (simplemail.SimpleMailPrefs.getBool("cleanonexit")) 
      simplemail.SimpleMailMain.emptyOnExit();
    if (simplemail.SimpleMailOverlay.openedWindows.length > 0) {
      for (var i = 0; i < simplemail.SimpleMailOverlay.openedWindows.length; i++)
        simplemail.SimpleMailOverlay.openedWindows[i].close();
    }
    // userok: async
    if (simplemail.SimpleMailPrefs.getBool("cleandatabase")) 
      simplemail.SimpleMailOverlay.storage.doCleanDataBase(); 
  },  
  
  pub.emptyOnExit = function() {
    if (!simplemail.SimpleMailManageFolder.isTrashEmpty()) {
      var tfolders = simplemail.SimpleMailOverlay.storage.getFolders();
      for (var i in tfolders) {
        var children = tfolders[i];
        for (var j in children) {
          if (children[j].id == simplemail.SimpleMailModel.SimpleMailFolder.TRASH) {
            var folderTrash = children[j];
            break;
          }
        }
      }
      
      simplemail.SimpleMailManageFolder.askDeleteFolder(folderTrash, simplemail.SimpleMailBundle.getString("emptyTrash"), true, true);
    }
  }
  
  return pub;
}();               