var action = window.arguments[0].action;  

function initialize() {
  document.title = action.id ? simplemail.SimpleMailBundle.getString("editAction")
                             : simplemail.SimpleMailBundle.getString("newAction");
  populateName();
  populateFolder();
  populateCharset();

  simplemail.SimpleMailUtils.selectItem("name", action.name);
  switch(action.name) {
    case "folder":
        simplemail.SimpleMailUtils.selectItem("folder", action.param);
        break;
    case "sound":
        simplemail.SimpleMailDom.get("sound-path").value = action.param;
        break;
    case "color":
        simplemail.SimpleMailUtils.selectItem("color", action.param);
        simplemail.SimpleMailDom.get("color").style.color = SimpleMailCOLORS[action.param];
        break;
    case "charset":
        simplemail.SimpleMailUtils.selectItem("charset", action.param);
        break;
    case "forward":
        simplemail.SimpleMailDom.get("forward-mail").value = action.param;
        break;
  }
  onSelectName();
}

function onAccept() {
  action.name = simplemail.SimpleMailDom.get("name").selectedItem.value;
  switch(action.name) {
    case "folder":
        action.param = simplemail.SimpleMailDom.get("folder").selectedItem.value;
        break;
    case "sound":
        action.param = simplemail.SimpleMailDom.get("sound-path").value;
        break;
    case "color":
        action.param = simplemail.SimpleMailDom.get("color").selectedItem.value;
        break;
    case "charset":
        action.param = simplemail.SimpleMailDom.get("charset").selectedItem.label;
        break;
    case "forward":
        action.param = simplemail.SimpleMailDom.get("forward-mail").value;
        break;
    default:
        action.param = null;
        break;
  }
}

function onCancel() {
  window.arguments[0].action = null;
}

function populateName() {
  var names = simplemail.SimpleMailModel.SimpleMailAction.getNames();
  var popup = simplemail.SimpleMailDom.get("name").menupopup;
  for(var i in names) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", simplemail.SimpleMailBundle.getString(names[i]));
    menuitem.setAttribute("value", names[i]);
    popup.appendChild(menuitem);
  }
}

function populateFolder() {
  simplemail.SimpleMailOverlay = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
  var tfolders = simplemail.SimpleMailOverlay.storage.getFolders();

  function forEachFolder(folderId, onFolder, level) {
    if (!level) level = 0;
    var children = tfolders[folderId];
    for (var i in children) {
      onFolder(children[i], level);
      forEachFolder(children[i].id, onFolder, level + 1);
    }
  }
  
  var popup = simplemail.SimpleMailDom.get("folder").menupopup;
  forEachFolder(0, function(folder, level) {
    var indent = "";
    for(var i = 0; i < level; i++) indent += "  ";
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", indent + folder.getName());
    menuitem.setAttribute("value", folder.id);
    popup.appendChild(menuitem);
  });
  
  popup.parentNode.selectedIndex = 0;
}

function populateCharset() {
  var popup = simplemail.SimpleMailDom.get("charset").menupopup;
  var charsets = simplemail.SimpleMailUtils.getDefaultCharsets();
  for(var i = 0; i < charsets.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", charsets[i]);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}

function onSelectName() {
  var name = simplemail.SimpleMailDom.get("name").selectedItem.value;
  var names = simplemail.SimpleMailModel.SimpleMailAction.getNames();
  var param;

  for(var i in names) {
    var element = simplemail.SimpleMailDom.get(names[i]);
    if (element) {
      element.hidden = names[i] != name;
      if (names[i] == name) param = element;
    }
  }
  simplemail.SimpleMailDom.get("param-label").hidden = !param || param.nodeName == "label";
}

function browseSound() {
  var file = simplemail.SimpleMailFile.chooseFile("open", ["*.wav"]);
  if (file) {
    simplemail.SimpleMailDom.get("sound-path").value = file.path;
  }
}

function clearSound() {
  simplemail.SimpleMailDom.get("sound-path").value = null;
}