function editrules_initialize() {
  simplemail.SimpleMailOverlay = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
  var rule = window.arguments[0].rule;
  
  document.title = rule.id ? simplemail.SimpleMailBundle.getString("editRule") : simplemail.SimpleMailBundle.getString("newRule");
  editrules_populateProperty();
  simplemail.SimpleMailUtils.selectItem("property", rule.property);
  simplemail.SimpleMailDom.get("not").checked = rule.not;
  editrules_populateCondition();
  simplemail.SimpleMailUtils.selectItem("condition", rule.condition);
  editrules_populateSize();
  editrules_populateAccountId();
  editrules_setParam(rule.param);
}

function editrules_onAccept() {
  var rule       = window.arguments[0].rule;
  rule.property  = simplemail.SimpleMailDom.get("property").selectedItem.value;
  rule.not       = simplemail.SimpleMailDom.get("not").checked;
  rule.condition = simplemail.SimpleMailDom.get("condition").selectedItem.value;
  rule.param     = editrules_getParam();
}

function editrules_onCancel() {
  window.arguments[0].rule = null;
}

function editrules_populateMenuList(menuId, values) {
  var popup = simplemail.SimpleMailDom.get(menuId).menupopup;
  simplemail.SimpleMailUtils.clearElement(popup);

  for(var i = 0; i < values.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", simplemail.SimpleMailBundle.getString(values[i]));
    menuitem.setAttribute("value", values[i]);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}

function editrules_populateProperty() {
  editrules_populateMenuList("property", simplemail.SimpleMailModel.SimpleMailRule.getProperties());
}

function editrules_populateCondition() {
  var property = simplemail.SimpleMailDom.get("property").value;
  editrules_populateMenuList("condition", simplemail.SimpleMailModel.SimpleMailRule.getConditions(property));
}

function editrules_populateSize() {
  editrules_populateMenuList("size", ["bytes", "kb", "mb"]);
}

function editrules_setParam(value) {
  var property = simplemail.SimpleMailDom.get("property").selectedItem.value;
  switch(property) {
    case "size":
        if (value > 1000000) {
          value = value / 1000000;
          simplemail.SimpleMailUtils.selectItem("size", "mb");
        }
        else if (value > 1000) {
          value = value / 1000;
          simplemail.SimpleMailUtils.selectItem("size", "kb");
        }
        break;
    case "accountId":
        simplemail.SimpleMailUtils.selectItem("accountId", value);
        break;
  }
  simplemail.SimpleMailDom.get("param").value = value;

  editrules_showParam();
}

function editrules_getParam() {
  var condition = simplemail.SimpleMailDom.get("condition").selectedItem.value;
  if (condition == "inAddressBook") return;

  var value = simplemail.SimpleMailDom.get("param").value;

  var property = simplemail.SimpleMailDom.get("property").selectedItem.value;
  switch(property) {
    case "size":
        var size = simplemail.SimpleMailDom.get("size").selectedItem.value;
        switch(size) {
          case "mb": value = value * 1000000; break;
          case "kb": value = value * 1000;    break;
        }
        value = value || 0;
        break;
    case "accountId":
        value = simplemail.SimpleMailDom.get("accountId").selectedItem.value;
        break;
  }
  return value;
}

function editrules_showParam() {
  var property  = simplemail.SimpleMailDom.get("property").selectedItem.value;
  var condition = simplemail.SimpleMailDom.get("condition").selectedItem.value;
  simplemail.SimpleMailDom.get("param").hidden = condition == "inAddressBook" || property == "accountId";
  simplemail.SimpleMailDom.get("param-label").hidden = condition == "inAddressBook";
  simplemail.SimpleMailDom.get("size").hidden = property != "size";
  simplemail.SimpleMailDom.get("accountId").hidden = property != "accountId";
}

function editrules_showTooltip(element) {
  var condition = simplemail.SimpleMailDom.get("condition").selectedItem.value;
  if (condition == "contains")
    simplemail.SimpleMailDom.get("tooltip").showPopup(element, -1, -1, "tooltip", null, "topright");
}

function editrules_hideTooltip() {
  simplemail.SimpleMailDom.get("tooltip").hidePopup();
}

function editrules_populateAccountId() {
  var popup     = simplemail.SimpleMailDom.get("accountId").menupopup;
  var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();

  for (var i = 0; i < taccounts.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", taccounts[i]);
    menuitem.setAttribute("value", taccounts[i].id);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}