if (typeof(simplemail) == "undefined")
  var simplemail = {a: "preferences.js"};

// userok: filterTree  -> simplemail.filterTree
// userok: accountTree -> simplemail.accountTree

simplemail.SimpleMailPreferences = function() {
  var pub      = {};
  pub.account  = [],
  pub.accounts = [],
  pub.filters  = [],
  pub.messages = [],
       
  pub.initialize = function() {  
    //console.error("SM.SimpleMailPreferences_initialize", simplemail, simplemail.SimpleMailOverlay);//userok_log
    
    simplemail.SimpleMailOverlay              = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
    simplemail.SimpleMailPreferences.accounts = simplemail.SimpleMailOverlay.storage.getAccounts();
    simplemail.accountTree                    = simplemail.SimpleMailDom.get("account-tree");
    simplemail.accountTree.view               = simplemail.accountTreeView;
    if (simplemail.accountTree.view.rowCount > 0) 
      simplemail.accountTree.view.selection.select(0);

    simplemail.SimpleMailPreferences.filters = simplemail.SimpleMailOverlay.storage.getFilters();
    simplemail.filterTree                    = simplemail.SimpleMailDom.get("filter-tree");
    simplemail.filterTree.view               = simplemail.filterTreeView;
    if (simplemail.filterTree.view.rowCount > 0) 
      simplemail.filterTree.view.selection.select(0);
    
    simplemail.SimpleMailDom.get("checkOnStartup").checked        = simplemail.SimpleMailPrefs.getBool("checkOnStartup");
    simplemail.SimpleMailDom.get("openInCurrentTab").checked      = simplemail.SimpleMailPrefs.getBool("openInCurrentTab");
    simplemail.SimpleMailDom.get("moveToTrash").checked           = simplemail.SimpleMailPrefs.getBool("moveToTrash");
    simplemail.SimpleMailDom.get("cleanonexit").checked           = simplemail.SimpleMailPrefs.getBool("cleanonexit");
    simplemail.SimpleMailDom.get("confirmdelete").checked         = simplemail.SimpleMailPrefs.getBool("confirmdelete");
    simplemail.SimpleMailDom.get("hideStatusNoMail").checked      = simplemail.SimpleMailPrefs.getBool("hideStatusNoMail");
    simplemail.SimpleMailDom.get("hideNoMail").checked            = simplemail.SimpleMailPrefs.getBool("hideNoMail");
    simplemail.SimpleMailDom.get("hideAll").checked               = simplemail.SimpleMailPrefs.getBool("hideAll");
    simplemail.SimpleMailDom.get("headersOnly").checked           = simplemail.SimpleMailPrefs.getBool("headersOnly");
    simplemail.SimpleMailDom.get("handleMailto").checked          = simplemail.SimpleMailPrefs.getBool("handleMailto"); // userok
    simplemail.SimpleMailDom.get("newMessagesInWindow").checked   = simplemail.SimpleMailPrefs.getBool("newMessagesInWindow");
    simplemail.SimpleMailDom.get("addressBookAddOnSend").checked  = simplemail.SimpleMailPrefs.getBool("addressBookAddOnSend");
    simplemail.SimpleMailDom.get("plaintextOnSend").checked       = simplemail.SimpleMailPrefs.getBool("plaintextOnSend");
    simplemail.SimpleMailDom.get("plaintextOnReceive").checked    = simplemail.SimpleMailPrefs.getBool("plaintextOnReceive");
    simplemail.SimpleMailDom.get("markReadTimeout").value         = simplemail.SimpleMailPrefs.getInt("markReadTimeout");
    simplemail.SimpleMailDom.get("dataDirectory").value           = simplemail.SimpleMailPrefs.getString("dataDirectory");
    simplemail.SimpleMailUtils.selectItem("popupNotification", simplemail.SimpleMailPrefs.getString("popupNotification"));
    simplemail.SimpleMailUtils.selectItem("sendreceiptresp", simplemail.SimpleMailPrefs.getString("sendreceiptresp"));
    simplemail.SimpleMailPrefs.getBool("transpopup") ? simplemail.SimpleMailDom.get("stylepopup").selectedIndex = 0
                                             : (simplemail.SimpleMailPrefs.getBool("fullpopup") ? simplemail.SimpleMailDom.get("stylepopup").selectedIndex = 1
                                             : simplemail.SimpleMailDom.get("stylepopup").selectedIndex = 2); 
    simplemail.SimpleMailDom.get("popupTimeout").value = simplemail.SimpleMailPrefs.getInt("popupTimeout");
    simplemail.SimpleMailPrefs.getBool("old") ?  simplemail.SimpleMailDom.get("styleicons").selectedIndex = 0
                                             : simplemail.SimpleMailPrefs.getBool("nuvola") ? simplemail.SimpleMailDom.get("styleicons").selectedIndex = 1
                                             : (simplemail.SimpleMailPrefs.getBool("oxygen") ? simplemail.SimpleMailDom.get("styleicons").selectedIndex = 2
                                             : simplemail.SimpleMailDom.get("styleicons").selectedIndex = 3);
    simplemail.SimpleMailDom.get("formatDate").selectedIndex = (simplemail.SimpleMailPrefs.getBool("eu")) ? 0 : 1;                                          
    simplemail.SimpleMailDom.get("removeImages").checked      = simplemail.SimpleMailPrefs.getBool("removeImages");
    simplemail.SimpleMailDom.get("newAttachs").checked        = simplemail.SimpleMailPrefs.getBool("newAttachs");
    simplemail.SimpleMailDom.get("mailSound").checked         = simplemail.SimpleMailPrefs.getBool("mailSound");
    simplemail.SimpleMailDom.get("mailSoundPath").value       = simplemail.SimpleMailPrefs.getString("mailSoundPath");
    simplemail.SimpleMailDom.get("warningPlainText").checked  = simplemail.SimpleMailPrefs.getBool("warningPlainText");
    simplemail.SimpleMailDom.get("cleandatabase").checked     = simplemail.SimpleMailPrefs.getBool("cleandatabase");
    simplemail.SimpleMailDom.get("enableLog").checked         = simplemail.SimpleMailPrefs.getBool("enableLog");
    simplemail.SimpleMailDom.get("popupOnTop").checked        = simplemail.SimpleMailPrefs.getBool("popupOnTop");
    simplemail.SimpleMailPrefs.getBool("messagesInWindow") ? simplemail.SimpleMailDom.get("openMail").selectedIndex = 0
                                             : (simplemail.SimpleMailPrefs.getBool("messagesInTab") ? simplemail.SimpleMailDom.get("openMail").selectedIndex = 1
                                             : simplemail.SimpleMailDom.get("openMail").selectedIndex = 2);
    simplemail.SimpleMailPreferences.showBrowseSoundDirectory();
    simplemail.SimpleMailPreferences.statusDisabled();
    
    // userok: set version
    var preferencesVersion = simplemail.SimpleMailDom.get("preferencesVersion");
    if (preferencesVersion)
      preferencesVersion.value = simplemail.SimpleMailOverlay.addonVersion;
  },
  
  pub.onSelectAccount = function() {
    simplemail.SimpleMailDom.get("account-edit").disabled =
    simplemail.SimpleMailDom.get("account-delete").disabled = !simplemail.accountTree.view.selection.getRangeCount();
  },

  // userok: async
  pub.editAccount = function(add) {
    if (add)
      simplemail.SimpleMailPreferences.account = simplemail.SimpleMailModel.SimpleMailAccount.create()
    else
      simplemail.SimpleMailPreferences.account = simplemail.SimpleMailPreferences.accounts[simplemail.accountTree.currentIndex];
    
    var param = { inn:{account: simplemail.SimpleMailPreferences.account }, out: null};
    openDialog("chrome://simplemail/content/preferences/account.xul", "simplemail-preferences-account-window", "chrome,centerscreen,modal,resizable=no", param);
    
    var account = simplemail.SimpleMailPreferences.account;
    if (param.out) {
      simplemail.SimpleMailOverlay.storage.saveAccount(function(acc) {
        if (add) {
          simplemail.SimpleMailPreferences.accounts.push(acc);
          simplemail.accountTreeView.treebox.rowCountChanged(simplemail.accountTreeView.rowCount - 1, 1);
          simplemail.accountTree.view.selection.select(simplemail.accountTreeView.rowCount - 1);
        } else
          simplemail.accountTreeView.treebox.invalidateRow(simplemail.accountTree.currentIndex);   
      }, account);
    }
  },

  // userok: async
  pub.deleteAccounts = function() {
    var confirmText = simplemail.SimpleMailBundle.getString("deleteAccounts");
    if (simplemail.SimpleMailUtils.confirm(confirmText)) {
      simplemail.accountTreeView.forEachSelected(function(index) {
        var ms = simplemail.SimpleMailOverlay.storage.getAccountMessages(simplemail.SimpleMailPreferences.accounts[index].id);
        simplemail.SimpleMailPreferences.messages = simplemail.SimpleMailPreferences.messages.concat(ms);
      });
      if (simplemail.SimpleMailPreferences.messages.length) {
        var confirmText = simplemail.SimpleMailBundle.getString("deleteAccountMessages");
        simplemail.SimpleMailOverlay.askDeleteMail(simplemail.SimpleMailPreferences.messages, confirmText, window);
      }
      simplemail.accountTreeView.forEachSelected(function(index) {
        simplemail.SimpleMailOverlay.storage.deleteAccount(function(acc, idx) {
          simplemail.SimpleMailPreferences.accounts.splice(idx, 1);
          simplemail.accountTreeView.treebox.rowCountChanged(idx, -1);          
        }, simplemail.SimpleMailPreferences.accounts[index], index);
      });
    }
  },

  pub.hideStatusNoMail = function(value) {
    simplemail.SimpleMailPrefs.setBool('hideStatusNoMail', value);
    simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.hideNoMail = function(value) {
    simplemail.SimpleMailPrefs.setBool('hideNoMail', value);
    simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.hideAll = function(value) {
    simplemail.SimpleMailPrefs.setBool('hideAll', value);
    simplemail.SimpleMailPreferences.statusDisabled();
    simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.statusDisabled = function () {
    if (simplemail.SimpleMailPrefs.getBool("hideAll")) {
      simplemail.SimpleMailDom.get("hideStatusNoMail").disabled = true;
      simplemail.SimpleMailPrefs.clear('hideStatusNoMail');
    } else {
      simplemail.SimpleMailDom.get("hideStatusNoMail").disabled = false;
      simplemail.SimpleMailPrefs.clear('hideAll');
    }
  },

  pub.stylepopup = function(selectedIndex) {
    if (simplemail.SimpleMailDom.get("stylepopup").selectedIndex == 0) {
      simplemail.SimpleMailPrefs.setBool('transpopup', true);
      simplemail.SimpleMailPrefs.setBool('fullpopup', false);
      simplemail.SimpleMailPrefs.setBool('customPopup', true);
    } else if (simplemail.SimpleMailDom.get("stylepopup").selectedIndex == 1){
      simplemail.SimpleMailPrefs.setBool('transpopup', false);
      simplemail.SimpleMailPrefs.setBool('fullpopup', true);
      simplemail.SimpleMailPrefs.setBool('customPopup', true);
    } else {
      simplemail.SimpleMailPrefs.setBool('transpopup', false);
      simplemail.SimpleMailPrefs.setBool('fullpopup', false);
      simplemail.SimpleMailPrefs.setBool('customPopup', false);
    }
  },

  pub.browseDataDirectory = function() {
    var file = simplemail.SimpleMailFile.chooseFile("folder");
    if (file) {
      simplemail.SimpleMailDom.get("dataDirectory").value = file.path;
      simplemail.SimpleMailPrefs.setString("dataDirectory", file.path);
    }
  },

  pub.defaultDataDirectory = function() {
    simplemail.SimpleMailPrefs.clear("dataDirectory");
    simplemail.SimpleMailDom.get("dataDirectory").value = simplemail.SimpleMailPrefs.getString("dataDirectory");
  },

  pub.showBrowseSoundDirectory = function(){
    if (!simplemail.SimpleMailPrefs.getBool("mailSound")) {
      simplemail.SimpleMailDom.get("mailSoundPath").disabled   = true;
      simplemail.SimpleMailDom.get("browseMailSound").disabled = true;
    } else {
      simplemail.SimpleMailDom.get("mailSoundPath").disabled   = false;
      simplemail.SimpleMailDom.get("browseMailSound").disabled = false;
    }
 },

  pub.browseSoundDirectory = function() {
    var file = simplemail.SimpleMailFile.chooseFile("open", ["*.wav"]);
    if (file) {
      simplemail.SimpleMailDom.get("mailSoundPath").value = file.path;
      simplemail.SimpleMailPrefs.setString("mailSoundPath", file.path);
    }
  },

  pub.styleicons = function(selectedIndex) {
    if (simplemail.SimpleMailDom.get("styleicons").selectedIndex == 0) {
      simplemail.SimpleMailPrefs.setBool('old', true);
      simplemail.SimpleMailPrefs.clear('nuvola');
      simplemail.SimpleMailPrefs.clear('oxygen');
      simplemail.SimpleMailPrefs.clear('australis');
    } else if (simplemail.SimpleMailDom.get("styleicons").selectedIndex == 1){
      simplemail.SimpleMailPrefs.clear('old');
      simplemail.SimpleMailPrefs.setBool('nuvola', true);
      simplemail.SimpleMailPrefs.clear('oxygen');
      simplemail.SimpleMailPrefs.clear('australis');
    } else if (simplemail.SimpleMailDom.get("styleicons").selectedIndex == 2){
      simplemail.SimpleMailPrefs.clear('old');
      simplemail.SimpleMailPrefs.clear('nuvola');
      simplemail.SimpleMailPrefs.setBool('oxygen', true);
      simplemail.SimpleMailPrefs.clear('australis');
    } else if (simplemail.SimpleMailDom.get("styleicons").selectedIndex == 3){
      simplemail.SimpleMailPrefs.clear('old');
      simplemail.SimpleMailPrefs.clear('nuvola');
      simplemail.SimpleMailPrefs.clear('oxygen');
      simplemail.SimpleMailPrefs.setBool('australis', true);
    }
  },

  pub.formatDate = function(selectedIndex) {
    if (simplemail.SimpleMailDom.get("formatDate").selectedIndex == 0) {
      simplemail.SimpleMailPrefs.setBool('eu', true);
      simplemail.SimpleMailPrefs.clear('us');
    } else if (simplemail.SimpleMailDom.get("formatDate").selectedIndex == 1){
      simplemail.SimpleMailPrefs.setBool('us', true);
      simplemail.SimpleMailPrefs.clear('eu');
    }
  }, 

  pub.openMail = function(selectedIndex) {
    if (simplemail.SimpleMailDom.get("openMail").selectedIndex == 0) {
      simplemail.SimpleMailPrefs.setBool('messagesInWindow', true);
      simplemail.SimpleMailPrefs.clear('messagesInTab');
    } else if (simplemail.SimpleMailDom.get("openMail").selectedIndex == 1){
      simplemail.SimpleMailPrefs.clear('messagesInWindow');
      simplemail.SimpleMailPrefs.setBool('messagesInTab', true);
    } else if (simplemail.SimpleMailDom.get("openMail").selectedIndex == 2){
      simplemail.SimpleMailPrefs.clear('messagesInTab');
      simplemail.SimpleMailPrefs.clear('messagesInWindow');
    }
  },

  pub.helpWindow = null,
  
  pub.onHelp = function() {
    simplemail.SimpleMailOverlay.helpWindow = window.open("http://www.userlogos.org/forum/simplemail");
  }, 

  pub.onAccept = function() {
    //console.error("pref.onAccept1", this);//userok_log
    if (!simplemail.SimpleMailDom.get("mailSoundPath").value && simplemail.SimpleMailDom.get("mailSound").checked) 
      simplemail.SimpleMailPrefs.setBool('mailSound', false); 
    
    // apply filter now
    if (simplemail.SimpleMailDom.get("applyfilter").checked) {
      //console.error("SM.pref_onAccept2", this);//userok_log
      simplemail.SimpleMailPrefs.clear('applyfilter');
      var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
      var msg       = [];
      for (var i = taccounts.length - 1; i >= 0; i--)
        msg = msg.concat(simplemail.SimpleMailOverlay.storage.getAccountMessages(taccounts[i].id));
  
      if (msg) {
        var filterManager = new simplemail.SimpleMailModel.SimpleMailFilterManager(simplemail.SimpleMailOverlay.storage, msg);
        var len           = msg.length;
        var tfolders      = simplemail.SimpleMailOverlay.storage.getFolders();
        
        for (var i = len - 1; i >= 0; i--) {
          for (var j in tfolders) {
            var children = tfolders[j];
            for (var k in children) {
              if (children[k].id == msg[i].folderId) {
                var msgParentId = children[k].parentId;
              }
            }
          }

          if (msg[i].folderId == simplemail.SimpleMailModel.SimpleMailFilter.INBOX | msgParentId == simplemail.SimpleMailModel.SimpleMailFilter.INBOX)  {
            var msgsInbox = filterManager.execute(msg[i], simplemail.SimpleMailModel.SimpleMailFilter.INBOX);
            simplemail.SimpleMailOverlay.storage.saveMessageState(msgsInbox);
          }
          if (msg[i].folderId == simplemail.SimpleMailModel.SimpleMailFilter.SENT | msgParentId == simplemail.SimpleMailModel.SimpleMailFilter.SENT)  {
            var msgsSent = filterManager.execute(msg[i], simplemail.SimpleMailModel.SimpleMailFilter.SENT);
            simplemail.SimpleMailOverlay.storage.saveMessageState(msgsSent);
          }
        }
      }
    }
    
    // userok: handle Mailto links
    simplemail.SimpleMailOverlay.handleMailto();
      
    //
    var mainWindow = simplemail.SimpleMailOverlay.getMainWindow(true);
    window.close();
    if (mainWindow) 
      mainWindow.history.go();
  }
  
  //console.error("SM_prefs", this);//userok_log
  
  return pub;
}();

simplemail.accountTreeView = function() {
  var pub = {
    get rowCount() {
      return simplemail.SimpleMailPreferences.accounts.length;
    }
  };
    
  pub.getCellText = function(row, column) {
    var name = column.id.replace(/account-/, "");
    return simplemail.SimpleMailPreferences.accounts[row][name];
  },
  
  pub.getImageSrc = function(row, column) {
    if (column.id == "account-image") {
      return simplemail.SimpleMailFile.getEnvelopeIconURL(simplemail.SimpleMailPreferences.accounts[row].color);
    }
  },
  
  pub.action = function() {
    simplemail.SimpleMailPreferences.editAccount();
  },
  
  pub.delete = function() {
    simplemail.SimpleMailPreferences.deleteAccounts();
  },

  pub.canDrop = function(row, orientation) {
    return simplemail.dragObserverPrefs.source == simplemail.accountTree;
  },
  
  pub.drop = function(row, orientation) {
    if (orientation == simplemail.accountTreeView.DROP_AFTER) {
      row++;
    }
    var move = new Array();
    simplemail.accountTreeView.forEachSelected(function(index) {
      move.unshift(simplemail.SimpleMailPreferences.accounts[index]);
      simplemail.SimpleMailPreferences.accounts.splice(index, 1);
      simplemail.accountTreeView.treebox.rowCountChanged(index, -1);
      if (index < row) row--;
    });
    simplemail.SimpleMailPreferences.accounts.splice.apply(simplemail.SimpleMailPreferences.accounts, [row, 0].concat(move));
    simplemail.accountTreeView.treebox.rowCountChanged(row, move.length);
    simplemail.SimpleMailOverlay.storage.saveAccounts(simplemail.SimpleMailPreferences.accounts);

    simplemail.dragObserverPrefs.source = null;
  },
  
  pub.getParentIndex = function(row) {
    return -1;
  }

  return pub;
}();  

simplemail.DefaultTreeView.extend(simplemail.accountTreeView);

simplemail.filterTreeView = function() {
  var pub = {
    get rowCount() {
      return simplemail.SimpleMailPreferences.filters.length;
    }
  };
  
  pub.getCellText = function(row, column) {
    var name  = column.id.replace(/filter-/, "");
    var value = simplemail.SimpleMailPreferences.filters[row][name];
    return simplemail.SimpleMailBundle.getString(value) || value;
  },
  
  pub.action = function() {
    simplemail.filterTreeView.editFilter();
  },
  
  pub.delete = function() {
    simplemail.filterTreeView.deleteFilters();
  },

  pub.canDrop = function(row, orientation) {
    return simplemail.dragObserverPrefs.source == simplemail.filterTree;
  },
  
  pub.drop = function(row, orientation) {
    if (orientation == simplemail.filterTreeView.DROP_AFTER)
      row++;

    var move = [];
    simplemail.filterTreeView.forEachSelected(function(index) {
      move.unshift(simplemail.SimpleMailPreferences.filters[index]);
      simplemail.SimpleMailPreferences.filters.splice(index, 1);
      simplemail.filterTreeView.treebox.rowCountChanged(index, -1);
      if (index < row) row--;
    });
    simplemail.SimpleMailPreferences.filters.splice.apply(simplemail.SimpleMailPreferences.filters, [row, 0].concat(move));
    simplemail.filterTreeView.treebox.rowCountChanged(row, move.length);
    simplemail.SimpleMailOverlay.storage.saveFilters(simplemail.SimpleMailPreferences.filters); // userok: saveFilters uses async func saveFilter

    simplemail.dragObserverPrefs.source = null;
  },
  
  pub.getParentIndex = function(row) {
    return -1;
  }

  return pub;
}();

simplemail.DefaultTreeView.extend(simplemail.filterTreeView);

simplemail.filterTreeView.onSelectFilter = function() {
  simplemail.SimpleMailDom.get("filter-edit").disabled =
    simplemail.SimpleMailDom.get("filter-delete").disabled = !simplemail.filterTree.view.selection.getRangeCount();
}

// userok: async
simplemail.filterTreeView.editFilter = function(add) {
  //console.error("SM.preference_editFilter", this);//userok_log
  if (add)
    var tfilter  = simplemail.SimpleMailModel.SimpleMailFilter.create()
  else {
    var fltrIdx  = simplemail.filterTree.currentIndex;
    var fltrOrig = simplemail.SimpleMailPreferences.filters[fltrIdx];
    var tfilter  = new simplemail.SimpleMailModel.SimpleMailFilter(fltrOrig.id, fltrOrig.index, fltrOrig.name, fltrOrig.type, fltrOrig.rules.slice(), fltrOrig.actions.slice());
  }
  
  var param = { filter: tfilter };
  openDialog("chrome://simplemail/content/preferences/filter/filter.xul", "simplemail-preferences-filter-window", "chrome,centerscreen,modal,resizable", param);
  if (!param.filter)
    return;
  
  simplemail.SimpleMailOverlay.storage.saveFilter(function(fltr) {
    if (add) {
      simplemail.SimpleMailPreferences.filters.push(fltr);
      simplemail.filterTreeView.treebox.rowCountChanged(simplemail.filterTreeView.rowCount - 1, 1);
      simplemail.filterTree.view.selection.select(simplemail.filterTreeView.rowCount - 1);
    } else {
      simplemail.SimpleMailPreferences.filters[fltrIdx] = fltr;
      simplemail.filterTreeView.treebox.invalidateRow(fltrIdx);
    }
  }, tfilter);
}

// userok: async
simplemail.filterTreeView.deleteFilters = function() {
  if (simplemail.SimpleMailUtils.confirm(simplemail.SimpleMailBundle.getString("deleteFilter"))) {
    simplemail.filterTreeView.forEachSelected(function(index) {
      simplemail.SimpleMailOverlay.storage.deleteFilter(function(filter, idx) {
        simplemail.SimpleMailPreferences.filters.splice(idx, 1);
        simplemail.filterTreeView.treebox.rowCountChanged(idx, -1);
      }, simplemail.SimpleMailPreferences.filters[index], index);
    });
  }
}

// Drag-n-Drop
simplemail.dragObserverPrefs = function(){
  var pub    = {};
  pub.source = null,
  
  pub.onDragStart = function(event, transferData, action) {
    if (event.target.nodeName != "treechildren") return;

    transferData.data = new TransferData();
    transferData.data.addDataForFlavour("text/unicode", "");
    simplemail.dragObserverPrefs.source = event.target.parentNode;
  },
  
  pub.getSupportedFlavours = function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  
  pub.onDrop = function(event, transferData, session) {}
  
  return pub;
}();